<!--
 * @Author: zhp
 * @Date: 2023-06-08 14:29:46
 * @LastEditTime: 2023-06-16 14:20:12
 * @LastEditors: zhp
 * @Description: 
-->
<template>
  <el-card shadow="never" class="aui-card--fill">
    <div class="mod-sys__user">
      <SearchBar :formConfigs="formConfig" ref="ruleForm" @headBtnClick="buttonClick">
        <!-- <el-badge :value="2" class="item">
          <el-button type="primary" size="small" @click="conditionSearch">条件搜索</el-button>
        </el-badge> -->
      </SearchBar>
      <div v-for="item in tableData" :key="item.id">
        <el-tooltip class="item" effect="dark" :content="'上线:' + item.online + ',下线:' + item.offline" placement="top">
          <div class="item">
            <span>
              {{item.name}}
            </span>
            <el-button style="margin-left:5px" type="text" icon="el-icon-edit" @click="handleEdit(item.id)"></el-button>
            <el-progress :stroke-width="26" :percentage="item.online ? item.online : ''">
            </el-progress>
          </div>
        </el-tooltip>

      </div>
      <!-- 弹窗, 新增 / 修改 -->
      <base-dialog :dialogTitle="addOrEditTitle" :dialogVisible="addOrUpdateVisible" @cancel="handleCancel"
        @confirm="handleConfirm" :before-close="handleCancel">
        <levelSetting-add ref="addOrUpdate" @refreshDataList="successSubmit">
        </levelSetting-add>
        <!-- <el-row slot="footer" type="flex" justify="end"> </el-row> -->
      </base-dialog>
      <base-dialog :dialogTitle="searchOrEditTitle" :dialogVisible="searchOrUpdateVisible" @cancel="handleSearchCancel"
        @confirm="handleSearchConfirm" :before-close="handleSearchCancel">
        <levelSetting-search ref="searchOrUpdate" @successSubmit="conditionSearchSubmit">
        </levelSetting-search>
        <el-row slot="footer" type="flex" justify="end">
          <el-col :span="12">
            <el-button size="small" type="primary" plain class="btnTextStyle" @click="handleSearchCancel">
              {{ $t("close") }}
            </el-button>
            <el-button size="small" class="btnTextStyle" type="primary" plain @click="handleSearchReset">{{
            $t("reset")
            }}</el-button>
            <el-button type="primary" size="small" class="btnTextStyle" @click="handleSearchConfirm">
              {{ $t("search") }}
            </el-button>
          </el-col>
        </el-row>
      </base-dialog>
    </div>
  </el-card>
</template>

<script>
import basicPage from "@/mixins/basic-page"
import basicSearch from "@/mixins/basic-search"
import levelSettingSearch from "./components/levelSettingSearch.vue"
import levelSettingAdd from "./components/levelSetting-add.vue"
import i18n from "@/i18n"
// import i18n from "@/i18n";
const tableProps = [
  {
    prop: "code",
    label: i18n.t('supplier.code'),
  },
  {
    prop: "name",
    label: i18n.t('supplier.name'),
  }
];
const tableBtn = [
  {
    type: "edit",
    btnName: i18n.t('edit'),
  },
  {
    type: "delete",
    btnName: i18n.t('delete'),
  }
];
export default {
  mixins: [basicPage, basicSearch],
  data() {
    return {
      urlOptions: {
        getDataListURL: "/supplier/qmsLevelSetting/page",
        deleteURL: "/supplier/qmsLevelSetting",
        exportURL: '/supplier/qmsLevelSetting/export',
        submitURL: '/supplier/qmsLevelSetting'
      },
      tableProps,
      tableBtn,
      productData: {},
      dataForm:{
        limit: 999,
        page:1
      },
      searchOrEditTitle: "",
      searchOrUpdateVisible: false,
      productOrEditTitle: "",
      addOrEditTitle: '',
      addOrUpdateVisible: false,
      productOrUpdateVisible: false,
      formConfig: [
        // {
        //   type: "",
        //   label: i18n.t("params.paramCode"),
        //   placeholder: i18n.t("params.paramCode"),
        //   param: "paramCode",
        // },
        // {
        //   type: "separate",
        // },
        {
          type: "button",
          btnName: i18n.t('add'),
          name: "add",
          color: "primary",
        },
        {
          type: "button",
          btnName: i18n.t('search'),
          name: "search",
          color: "primary",
          // plain: true,
        },
        {
          type: "button",
          btnName: i18n.t('export'),
          name: "export",
          color: "primary",
          // plain: true,
        }
      ],
    };
  },
  components: {
    levelSettingSearch,
    levelSettingAdd
  },
  methods: {
    //search-bar点击
    handleProductCancel() {
      this.productOrUpdateVisible = false;
      this.productOrEditTitle = "";
    },
    handleCurrentChange(val) {
      console.log(val);
      this.productData = val.newVal ? val.newVal : {}
    },
    setCurrent(index) {
      this.$refs.palletTable1.setCurrent("palletTable", index);
    },
    // handleSearchCancel() {
    //   this.searchOrEditTitle = "";
    //   this.searchOrUpdateVisible = false;
    // },
    conditionSearch() {
      this.searchOrEditTitle = "搜索";
      this.searchOrUpdateVisible = true;
      this.$nextTick(() => {
        this.$refs.searchOrUpdate.init();
      });
    },
    // handleConfirm() {
    //   this.$refs.addOrUpdate.dataFormSubmitHandle();
    // },
    // conditionSearchSubmit() {},
    conditionSearchSubmit(dataForm) {
      // console.log(key);
      // console.log(key);
      this.listQuery.name = dataForm.name
      this.listQuery.code = dataForm.code
      this.listQuery.page = 1;
      this.getDataList();
      this.searchOrUpdateVisible = false;
      // console.log(11111);
      // this.conditionSearchSubmit();
    },
    exportHandle() {
      this.$http.get(this.urlOptions.exportURL, { responseType: 'blob' }, {
        ...this.dataForm
      }).then((res) => {
        console.log(res)
        // if (res !== 0) {
        //   return this.$message.error(res.msg) 
        // }
        let fileName = ''
        const contentDisposition = res.headers['content-disposition']
        if (contentDisposition) {
          const temp = res.headers['content-disposition']
            .split(';')[1]
            .split('=')[1]
          // 对文件名乱码转义--【Node.js】使用iconv-lite解决中文乱码
          fileName = decodeURI(temp)
          console.log(temp)
        }
        const blob = new Blob([res.data])
        const reader = new FileReader()
        reader.readAsDataURL(blob)
        reader.onload = (e) => {
          const a = document.createElement('a')
          a.download = fileName
          a.href = e.target.result
          document.body.appendChild(a)
          a.click()
          document.body.removeChild(a)
        }
      }).catch(() => { })
    },
    handleClick(val) {
      if (val.type === "delete") {
        this.$confirm(`确定对[名称=${val.data.customerTypeName}]进行删除操作?`, "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
          .then(() => {
            this.$http.delete(this.urlOptions.deleteURL, { data: [val.data.id] }).then(({ data }) => {
              if (data && data.code === 0) {
                this.$message({
                  message: "操作成功",
                  type: "success",
                  duration: 1500,
                  onClose: () => {
                    this.getDataList();
                  },
                });
              } else {
                this.$message.error(data.msg);
              }
            });
          })
          .catch(() => { });
      }
    },
    handleEdit(id) {
      this.addOrEditTitle = '修改'
      this.addOrUpdateVisible = true;
      this.$nextTick(() => {
        this.$refs.addOrUpdate.init(id);
      });
    },
    // addOrUpdateHandle(productData) {
    //   this.addOrUpdateVisible = true;
    //   this.$nextTick(() => {
    //     this.$refs.addOrUpdate.init(productData);
    //   });
    // },
    buttonClick(val) {
      console.log(val);
      switch (val.btnName) {
        case "search":
          // this.listQuery.paramCode = val.paramCode;
          // console.log(i18n);
          this.listQuery.page = 1
          this.getDataList()
          break;
        case "export":
         this.exportHandle()
          break;
        case "add":
          this.addOrEditTitle = '新增'
          this.addOrUpdateVisible = true;
          this.addOrUpdateHandle()
          break;
        default:
      }
    },
  },
};
</script>
<style lang="css" scoped>


.item{
  width:500px;
  margin-top: 50px;
}
.el-progress{
  margin-top:5px
}
</style>
